   -- ஢ 㭪権 ⥪ AList.hs, ।-
   -- 祭  ࠡ   樠⨢묨 ᯨ᪠, ᮤ-
   -- 騬  ᥫ ⨯ (Integer,Double)
   -- ***************************************
   import AList
   ----------------------------------------------------
   test =   testAssoc     && testAssoc_if && testRassoc
         && testRassoc_if && testassFind
         && testAcons     && testPairlis
         && testAcons1    && testAcons2 && testDelpair
         && testPutassoc
         && testReKey     && testReData
         && testbKey      && testbDate
   ------------------------------------------
   testAssoc =   assoc 2 [(1,3.2)] (==) == []
              && assoc 2 [(11,3.1),(-2,4.1),(1,2.2)] (<)
                                        == [(-2,4.1)]
              && assoc 2 [(1,3.0),(-2,4.0),(2,1.0)] (==)
                                        == [(2,1.0)]
              && assoc (-22) [(-22,4.0),(1,2.0)] (<=)
                                        == [(-22,4.0)]
              && assoc (-22) [(-22,4.0),(1,2.0),(2,1.0)] (>)
                                        == [(1,2.0)]
   -------------------------------------------------
   testAssoc_if =   assoc_if [(1,3.0)] (<0) == []
                 && assoc_if [(11,3.0),(-2,4.0)] (<0)
                                            == [(-2,4.0)]
                 && assoc_if [(1,3.0),(-2,4.0),(2,1.0)] (==2) 
                                            == [(2,1.0)]
                 && assoc_if [(-22,4.0),(1,2.0)] odd
                                            == [(1,2.0)]
                 && assoc_if [(-22,4.0),(2,1.0)] even
                                            == [(-22,4.0)]
   -------------------------------------------------------
   testRassoc =   rassoc 2.0 [(1,3.0)] (==) == []
               && rassoc 2.0 [(11,3.0),(-2,-4.0),(1,2.0)] (<) 
                                            == [(-2,-4.0)]
               && rassoc 1.0 [(1,3.0),(-2,4.0),(2,1.0)] (==) 
                                            == [(2,1.0)]
               && rassoc (-22.0) [(22,-22.0),(1,2.0)] (<=)
                                            == [(22,-22.0)]
               && rassoc (-2.0) [(-2,-2.0),(1,2.0),(2,1.0)] (>) 
                                            == [(1,2.0)]
   -----------------------------------------------------
   testRassoc_if =   rassoc_if [(1,3.0)] (<0.0) == []
                  && rassoc_if [(11,-3.0),(-2,4.0)] (>0.0) 
                                                == [(-2,4.0)]
                  && rassoc_if [(1,3.0),(-2,4.0),(2,1.0)] (==1.0) 
                                                == [(2,1.0)]
   -----------------------------------------------------------
   testassFind =   assFind 3 33.0 [(3,33.0),(2,22.0),(4,11.0)]
                && assFind 2 22.0 [(3,33.0),(2,22.0),(4,11.0)]
                && assFind 2 22.0 [(2,22.0)] 
                ----------------------------------------------------
                --  ᮡ⥩ ⢥ 䬥⨪
                ----------------------------------------------------
                && not (assFind 3 3.0 [(3,7.0),(3,3.000001)])
                &&      assFind 3 3.0 [(3,7.0),(3,3.0000001)]
   ----------------------------------------------------------
   testAcons =   acons (-1) (-2.0) [] == [(-1,-2.0)]
              && acons 1 2.0 [(1,3.0)]
                                      == [(1,2.0),(1,3.0)]
              && acons (-2) 4.0 [(1,3.0),(-2,4.0)]
                                      == [(-2,4.0),(1,3.0),(-2,4.0)]
   -----------------------------------------------------------------
   testPairlis =   pairlis [1,2,3,4] [11.0,22.0,33.0,44.0] []
                        == [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                && pairlis [1,2,3] [11.0,22.0,33.0]
                           [(5,55.0),(1,111.0),(3,333.0)]
                        == [(1,11.0),(2,22.0),(3,33.0),(5,55.0),
                            (1,111.0),(3,333.0)]
   ------------------------------------------------
   testAcons1 =   acons1 3 33.0 [(1,11.0),(2,22.0)]
                             == [(1,11.0),(2,22.0),(3,33.0)]
               && acons1 3 33.0 [(1,11.0),(4,44.0)]
                             == [(1,11.0),(3,33.0),(4,44.0)]
               && acons1 3 33.0 [(4,44.0)]
                             == [(3,33.0),(4,44.0)]
               && acons1 3 33.0 [(3,1.0)]
                             == [(3,33.0),(3,1.0)]
   -----------------------------------------------------
   testAcons2 =   acons2 3 33.0 []         == [(3,33.0)]
               && acons2 2 22.0 [(2,22.0)] == [(2,22.0)]
               && acons2 5 55.0 [(44,4.0),(45,3.0),(3,2.0)]
                    == [(5,55.0),(44,4.0),(45,3.0),(3,2.0)]
               && acons2 3  5.0 [(2,22.0),(4,11.0)]
                            == [(2,22.0),(4,11.0),(3,5.0)]
               && acons2 3 15.0 [(2,22.0),         (4,11.0)]
                             == [(2,22.0),(3,15.0),(4,11.0)]
               && acons2 3 33.0 [(3,33.0),(2,22.0),(4,11.0)]
                             == [(3,33.0),(2,22.0),(4,11.0)]
               && acons2 2 22.0 [(3,33.0),(2,22.0),(4,11.0)]
                             == [(3,33.0),(2,22.0),(4,11.0)]
               ---------------------------------------------
               && acons2 3  3.0 [(3,7.0),(3,5.0)]
                             == [(3,7.0),(3,5.0),(3,3.0)]
               && acons2 3  3.0 [(3,7.0),(3,4.0),        (3,1.0)]
                             == [(3,7.0),(3,4.0),(3,3.0),(3,1.0)]

               && acons2 3  3.0 [(3,3.0),(3,3.0),(3,3.0)]
                             == [(3,3.0)]
               ------------------------------------
               -- ஥ 樠⨢ ᯨ᪠,
               -- 㯮冷祭  뢠 
               ------------------------------------
               && acons2 1 1.0
                   (acons2 10 1.0
                     (acons2 10 2.0
                       (acons2 5 2.0
                         (acons2 4 1.0
                           (acons2 1 3.0 [])))))
               == [(1,3.0),(5,2.0),(10,2.0),(4,1.0),(10,1.0),(1,1.0)]
   ------------------------------------------------------------------
   testDelpair =   delpair 1 [(1,11.0)]
                          == []
                && delpair 3 [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                          == [(1,11.0),(2,22.0),         (4,44.0)]
                && delpair 4 [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                          == [(1,11.0),(2,22.0),(3,33.0)]
                && delpair 5 [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                          == [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                && delpair 5 [(5,11.0),(2,22.0),(5,33.0),(5,44.0)]
                          == [         (2,22.0)                  ]
   ----------------------------------------------------------------
   testPutassoc =    putassoc 2 222.0 [(1,11.0),(2, 22.0),(3,33.0)]
                                   == [(1,11.0),(2,222.0),(3,33.0)]
                  && putassoc 2 222.0 [(1,11.0),(3, 33.0),(4,44.0)]
                                   == [(1,11.0),(3, 33.0),(4,44.0)]
                  && putassoc 2 10.0 
                              [(1,11.0),(2, 9.0),(3,7.0),(4,5.0)]
                           == [(1,11.0),(2,10.0),(3,7.0),(4,5.0)]
                  && putassoc 4 5.0 [(1,11.0),(3,9.0),(4,7.0)]
                           ==       [(1,11.0),(3,9.0),(4,5.0)]
                  && putassoc 1 2.0 [(1,11.0)]
                           ==       [(1,2.0)]
   ---------------------------------------------------------
   testReKey =   rekey [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                                  == [1,2,3,4]
              && rekey [(1,11.0)] == [1]
              && rekey []         == []
   -----------------------------------------------------------
   testReData =   redata [(1,11.0),(2,22.0),(3,33.0),(4,44.0)]
                                    == [11.0,22.0,33.0,44.0]
               && redata [(1,11.0)] == [11.0]
               && redata []         == []
   ----------------------------------------------------------
   testbKey =   bubbleKey [(3,0.5),(-1,0.1),(2,0.6),(-1,0.2)]
                       == [(-1,0.1),(-1,0.2),(2,0.6),(3,0.5)]
             && bubbleKey [(7,-1.0),(6,-2.0),(5,-3.0),(3,-4.0)]
                       == [(3,-4.0),(5,-3.0),(6,-2.0),(7,-1)]
             && bubbleKey [(7,-1.2),(7,3.4),(7,0.1),(3,10.0)]
                       == [(3,10.0),(7,-1.2),(7,3.4),(7,0.1)]
   ----------------------------------------------------------
   testbDate =   bubbleDate [(3,5.5),(0,1.1),(2,6.6),(1,2.2)]
                         == [(0,1.1),(1,2.2),(3,5.5),(2,6.6)]
              && bubbleDate [(80,0.7),(2,0.6),(-22,0.5),(12,-3.1)]
                         == [(12,-3.1),(-22,0.5),(2,0.6),(80,0.7)]
